package it.unimi.di.archive4j.scratch;

import it.unimi.di.archive4j.Archive;
import it.unimi.di.archive4j.ArchiveLoader;
import it.unimi.di.archive4j.DocumentSummary;
import it.unimi.dsi.fastutil.io.BinIO;
import it.unimi.dsi.util.StringMap;

import java.util.Iterator;

/**
 * Dumps an archive on standard output. Give the basename, the name (or the string "null") for the
 * url map and (possibly) the original term map.
 */
public class DumpArchive {


	@SuppressWarnings("unchecked")
	public static void main( String[] args ) throws Exception {
		Archive a = null;
		DocumentSummary d;
		StringMap<? extends CharSequence> tmap = null;

		switch ( args.length ) {
		case 1:
			a = ArchiveLoader.getInstance( args[ 0 ] );
			break;
		case 2:
			a = ArchiveLoader.getInstance( args[ 0 ], args[ 1 ] );
			break;
		case 3:
			if ( args[ 1 ].equals( "null" ) ) a = ArchiveLoader.getInstance( args[ 0 ] );
			else a = ArchiveLoader.getInstance( args[ 0 ], args[ 1 ] );
			tmap = (StringMap<? extends CharSequence>)BinIO.loadObject( args[ 2 ] );
			break;

		default:
			throw new IllegalArgumentException( "Argument length must be 1 2 or 3" );

		}

		int docOrd = 0;
		final Iterator<DocumentSummary> ii = a.iterator();

		while ( ii.hasNext() ) {
			d = ii.next();

			System.out.println( " == " + docOrd + "th document ( # " + d.id() + " ) " + ( d.uri() != null ? ": " + d.uri() + " " : "" ) + ") ==" );
			System.out.println( " =- Number of terms: " + d.size() );
			/*
			 * if ( d instanceof ArrayDocumentSummary ) ((ArrayDocumentSummary)d).sortTerms();
			 */
			int numberOfTerms = d.size();
			for ( int i = 0; i < numberOfTerms; i++ ) {
				final int term = d.term( i );
				System.out.print( ( tmap == null ? Integer.toString( term ) : tmap.list().get( term ) ) + ":" + d.count( i ) + " " );
			}
			System.out.println( "" );

			docOrd++;
		}

	}

}
