package it.unimi.di.archive4j;

/*		 
 * Copyright (C) 2008-2013 Alessio Orlandi and Sebastiano Vigna 
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


import it.unimi.di.archive4j.ArrayDocumentSummary;
import junit.framework.TestCase;




public class ArrayDocumentSummaryTestCase extends TestCase {

	public void testEquals() {
		ArrayDocumentSummary a = ArrayDocumentSummary.parse( "0 3 8 1:1 2:1 3:2 4:4 5:5 6:6 7:7 8:8", null );
		ArrayDocumentSummary b = ArrayDocumentSummary.parse( "0 3 8 2:1 1:1 4:4 3:2 5:5 6:6 7:7 8:8", null );
		
		assertEquals( a, b );
		assertEquals( a.sort(), b );
		assertEquals( b, a );
		assertEquals( b.sort(), a );
		
		assertEquals( a.hashCode(), b.hashCode() );
		assertEquals( a.sort().hashCode(), b.hashCode() );
		assertEquals( b.hashCode(), a.hashCode() );
		assertEquals( b.sort().hashCode(), a.hashCode() );

		a = ArrayDocumentSummary.parse( "0 3 8 1:1 2:1 3:2 4:4 5:5 6:6 7:7 9:9", null );
		b = ArrayDocumentSummary.parse( "0 3 8 2:1 2:1 4:4 3:2 5:5 6:6 7:7 8:8", null );

		assertFalse( a.equals( b ) );
		assertFalse( a.sort().equals( b ) );
		assertFalse( b.equals(a ) );
		assertFalse( b.sort().equals( a ) );
		
		assertFalse( ArrayDocumentSummary.parse( "0 3 2 1:1 2:1", null ).equals( ArrayDocumentSummary.parse( "1 3 2 1:1 2:1", null ) ) );
		assertFalse( ArrayDocumentSummary.parse( "0 3 2 1:1 2:1", null ).equals( ArrayDocumentSummary.parse( "0 2 2 1:1 2:1", null ) ) );
		assertFalse( ArrayDocumentSummary.parse( "0 3 2 1:1 2:1", null ).equals( ArrayDocumentSummary.parse( "0 3 1 1:1", null ) ) );
	}
}
