package it.unimi.di.archive4j;

/*		 
 * Copyright (C) 2008-2013 Alessio Orlandi and Sebastiano Vigna 
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


import it.unimi.di.archive4j.ArrayArchive;
import it.unimi.di.archive4j.ArrayDocumentSummary;
import it.unimi.di.archive4j.IdentityFeaturizer;
import it.unimi.di.law.vector.ImmutableSparseVector;
import junit.framework.TestCase;

public class FeaturizersTest extends TestCase {

	private static final double EPSILON = 0.000001; 
	protected ArrayArchive archive; 
	
	@Override
	protected void setUp ( ) throws Exception 
	{
		archive = TestCollection.makeArrayArchive( TestCollection.testCollection1 );
	}
	public void testIdentity() throws Exception {
		
		final IdentityFeaturizer<ArrayDocumentSummary> featurizer = new IdentityFeaturizer<ArrayDocumentSummary>( archive );
		
		for ( ArrayDocumentSummary s : archive )
		{
			ImmutableSparseVector v = featurizer.get( s );
			for ( int i = 0; i < s.size(); i++ ) 
				assertEquals(  s.count( i ), (v.get( s.term(i) )), EPSILON);
		}
 	}
	
	
	/* TODO Missing tests for TF-IDF and BM25. */

}
